VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPoint"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private X3d As Double
Private Y3d As Double
Private Z3d As Double

Private xb As Double  'XY plane bearing
Private xr As Double  'XY plane range
Private yb As Double  'YZ plane bering
Private yr As Double  'YZ plane range
Private zb As Double  'ZX plane bering
Private zr As Double  'ZX plane range

Private changing As Integer

Private Sub CalcPolar()
  'Calc XY Plane, Z-axis (Y = Opposite, X = Ajacent)
  If (X3d = 0) Then
    xr = Abs(Y3d)
    If (Y3d > 0) Then
      xb = 90 / DEG_PER_RADIAN
    Else
      xb = -90 / DEG_PER_RADIAN
    End If
  Else
    xb = Atn(Y3d / X3d)
    If (X3d < 0) Then
      xr = -Sqr(X3d ^ 2 + Y3d ^ 2)
    Else
      xr = Sqr(X3d ^ 2 + Y3d ^ 2)
    End If
  End If
  
  
  'Calc YZ Plane X-axis (Y = Opposite, Z = Ajacent)
  If (Z3d = 0) Then
    yr = Abs(Y3d)
    If (Y3d > 0) Then
      yb = 90 / DEG_PER_RADIAN
    Else
      yb = -90 / DEG_PER_RADIAN
    End If
  Else
    yb = Atn(Y3d / Z3d)
    If (Z3d < 0) Then
      yr = -Sqr(Z3d ^ 2 + Y3d ^ 2)
    Else
      yr = Sqr(Z3d ^ 2 + Y3d ^ 2)
    End If
  End If
  
  'Calc ZX Plane Y-axis (Z = Opposite, X = Ajacent)
  If (X3d = 0) Then
    zr = Abs(Z3d)
    If (Z3d > 0) Then
      zb = 90 / DEG_PER_RADIAN
    Else
      zb = -90 / DEG_PER_RADIAN
    End If
  Else
    zb = Atn(Z3d / X3d)
    If (X3d < 0) Then
      zr = -Sqr(X3d ^ 2 + Z3d ^ 2)
    Else
      zr = Sqr(X3d ^ 2 + Z3d ^ 2)
    End If
  End If
  
End Sub

Public Property Get X() As Variant
  X = X3d
  
End Property

Public Property Let X(ByVal vNewValue As Variant)
  X3d = vNewValue
  If (changing = 2) Then
    CalcPolar
    changing = 0
  Else
    changing = changing + 1
  End If
  
End Property

Public Property Get Y() As Variant
  Y = Y3d
  
End Property

Public Property Let Y(ByVal vNewValue As Variant)
  Y3d = vNewValue
  If (changing = 2) Then
    CalcPolar
    changing = 0
  Else
    changing = changing + 1
  End If
  
End Property

Public Property Get Z() As Variant
  Z = Z3d
  
End Property

Public Property Let Z(ByVal vNewValue As Variant)
  Z3d = vNewValue
  If (changing = 2) Then
    CalcPolar
    changing = 0
  Else
    changing = changing + 1
  End If
  
End Property

Private Sub Class_Initialize()
  changing = 0
  
End Sub

Public Sub Rotate(Xaxis As Double, Yaxis As Double, Zaxis As Double)
  Dim xz, xy As Double
  Dim yz, yx As Double
  Dim zy, zx As Double
  
  'do X-Axis
  yb = yb + Xaxis
  xy = Sin(yb) * yr
  xz = Cos(yb) * yr
  
  'update coords
  Y3d = xy
  Z3d = xz
  CalcPolar
  
  'do Y-Axis
  zb = zb + Yaxis
  yz = Sin(zb) * zr
  yx = Cos(zb) * zr
  
  'update coords
  X3d = yx
  Z3d = yz
  CalcPolar
  
  'do Z-Axis
  xb = xb + Zaxis
  zy = Sin(xb) * xr
  zx = Cos(xb) * xr
  
  'update coords
  X3d = zx
  Y3d = zy
  CalcPolar

End Sub


Public Function Equals(objPoint As clsPoint) As Boolean
  Equals = ((objPoint.X = X3d) _
            And (objPoint.Y = Y3d) _
            And (objPoint.Z = Z3d))

End Function
