VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSurface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"clsPoint"
Attribute VB_Ext_KEY = "Member0" ,"clsPoint"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'local variable to hold collection
Private mcolPoints As Collection
Private mcolPolys As Collection

'public member objects
Public this As clsSurface
Public canvas As Form
Public reference As clsPoint

Public Sub Rotate(XaxisDeg As Double, YaxisDeg As Double, ZaxisDeg As Double)
  Dim objPt As clsPoint
  Dim objPoly As clsPoly
  Dim lngX As Long
  
  On Error GoTo err_routine
  
  'Clear the window w/current pen
  canvas.Refresh
  
  For Each objPt In mcolPoints
    objPt.Rotate XaxisDeg, YaxisDeg, ZaxisDeg
  Next
  
'Debug.Assert Form1.Hroll = 50 And Form1.Vroll = 50 And Form1.ZRoll = 50
  
  'paint the object
  're-allign the polygons in order from back to front
  For lngX = 1 To mcolPolys.Count
    mcolPolys.Item(lngX).SetZord
    If (lngX = 1) Then
      Set mcolPolys.Item(lngX).nxt = mcolPolys.Item(lngX + 1)
      Set mcolPolys.Item(lngX).prv = Nothing
    ElseIf (lngX = mcolPolys.Count) Then
      Set mcolPolys.Item(lngX).nxt = Nothing
      Set mcolPolys.Item(lngX).prv = mcolPolys.Item(lngX - 1)
    Else
      Set mcolPolys.Item(lngX).nxt = mcolPolys.Item(lngX + 1)
      Set mcolPolys.Item(lngX).prv = mcolPolys.Item(lngX - 1)
    End If
    
  Next

  For Each objPoly In mcolPolys
    objPoly.Sort
  Next
  
  'paint in order
  For Each objPoly In mcolPolys
    If (objPoly.prv Is Nothing) Then
      Exit For
    End If
  Next
  
  shown = 0
  objPoly.Show
  
  Exit Sub
err_routine:
  Select Case Err.Number
    Case 0
    
    Case Else
      MsgBox "Error " & Err.Number & ", " & Err.Description
  End Select
  
End Sub


Public Function Add(colPoints As Collection, Color As Long)
  Dim objNewPoly As clsPoly
  Dim objNewPoint As clsPoint
  Dim objPoint As clsPoint
  Dim Found As Boolean
  Dim lngX
  
  'create new polygon
  Set objNewPoly = New clsPoly
  Set objNewPoly.parent = this
  Set objNewPoly.this = objNewPoly
  Set objNewPoly.canvas = canvas
  objNewPoly.Color = Color
  
  For Each objNewPoint In colPoints
    Found = False
    
    'search existing points for new point
    For lngX = 1 To mcolPoints.Count
      Set objPoint = mcolPoints.Item(lngX)
      If (objNewPoint.Equals(objPoint)) Then
        Found = True
        Exit For
      End If
    Next
    
    If (Found) Then
      objNewPoly.Add CStr(lngX)
    Else
      mcolPoints.Add objNewPoint
      objNewPoly.Add mcolPoints.Count
    End If
  Next

  mcolPolys.Add objNewPoly

End Function

Public Property Get Point(vntIndexKey As Variant) As clsPoint
Attribute Point.VB_UserMemId = 0
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set Point = mcolPoints(vntIndexKey)
End Property



Public Property Get Count() As Long
    'used when retrieving the number of elements in the
    'collection. Syntax: Debug.Print x.Count
    Count = mcolPoints.Count
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)


    mcolPoints.Remove vntIndexKey
End Sub


Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mcolPoints.[_NewEnum]
End Property


Private Sub Class_Initialize()
    'creates the collection when this class is created
    Set mcolPoints = New Collection
    Set mcolPolys = New Collection
    
End Sub


Private Sub Class_Terminate()
    'destroys collection when this class is terminated
    Set mcolPoints = Nothing
End Sub

